function zeta = BianRes2( Y , Ncov , Mgdl , Ord , Theta , graph )
% zeta = BianRes2( Y , Ncov , Mgdl , Ord , Theta , graph ) valuta la 
% bianchezza dei residui calcolando Mgdl covarianze campionarie del-
% l'errore di previsione e restituise la quantita' zeta da confrontare 
% con CHI^2 per Mgdl gradi di liberta' ; Y contiene L campioni di nc-1 
% ingressi ed 1 uscita relativi ad un modello di ordine Ord , i cui 
% parametri sono Theta. Ncov e' la lunghezza della sequenza considerata. 
% graph = 1 se devono essere visualizzati i grafici.


  [ L , nc ] = size( Y ); %L numero di campioni;

  % Ncov lunghezza della sequenza considerata;

  Yo = Y(1+Ord:L,nc); %vettore delle uscite misurate;

        if( nc >= 2 )

    H = [ myhank( Y(:,nc) , L , Ord , 0 ) , myhank( Y(:,1),L,Ord,0 ) ];

        else H = myhank(  Y(:,1) , L , Ord , 0 );

        end;


        if( nc > 2)

          for input = 2:nc-1,

              H = [ H , myhank(  Y(:,input) , L , Ord , 0 ) ];

          end;

        end;

  Yp = H*Theta'; %vettore delle uscite previste;

if( graph == 1 )
  figure, subplot(211)
  plot([0:Ncov-1],Yo(1:Ncov),'-',[0:Ncov-1],Yp(1:Ncov),':')
% plot([0:L-Ord-1],Yo,'-',[0:L-Ord-1],Yp(1:L-Ord),':')
  title('Prediction (:) and observations (-)')
  xlabel('Samples'), ylabel('y(t)')
end;

  epserr=[]; %vettore dei residui;

  res=[]; %vettore delle covarianze campionarie;

  epserr=Yo-Yp(1:L-Ord);

if( graph == 1 )
  figure, subplot(212)
  plot([0:Ncov-1],epserr(1:Ncov)),title('Identified model residuals')
  xlabel('Samples'), ylabel('\epsilon(t)'), pause;


end;

           for i=1:Mgdl+1,

             res(i) = ( (epserr(1:Ncov))' * epserr(i:Ncov+i-1) )/Ncov;

           end;

if( graph == 1 )
     figure, plot([1:Mgdl+1],res,'-',[1:Mgdl+1],res,'o');
     title('Residual whiteness test'), xlabel('Correlation (\tau)'), pause;
end;

  zeta = Ncov *( res(2:Mgdl+1)*( res(2:Mgdl+1)' ) )/(res(1)*res(1));

return