function [zeta,J] = whiteness_res(Yiu1,N,ordmax)

[L,nc] = size(Yiu1); % Lunghezza effettiva della sequenza.

if(N+ordmax+8 > L), N = L - ordmax-8; end;

zeta = zeros(ordmax,1);
J = zeros(ordmax,1);
chi = 20.1 * ones(ordmax,1); % Chi^2 per 8 gradi di liberta'.

for i = 1:ordmax,

 [Theta,Ji,sigma_e,cov_e,err_e,yprev] = minquad3(Yiu1,N,i,0);
 
 J(i,1) = Ji;
 zeta(i,1) = bianres2( Yiu1 , N , 8 , i , Theta' , 0 );
 
 clear Theta;

end;

figure, plot([1:ordmax],zeta,'-',[1:ordmax],chi,':',[1:ordmax],zeta,'o')
title('Residual Whiteness Test'), xlabel('Identified ARX Model Order'), ylabel('\chi^{2}_{\alpha}(M) and \zeta_{N,M}')

figure, plot([1:ordmax],J,'-',[1:ordmax],J,'o')
title('Loss Function'), xlabel('Identified ARX Model Order'), ylabel('J(\theta_N)')

return

